#!/usr/bin/python

# Librarys import
import os
import socket
import time, datetime
import threading

# Server configuration
USER = "Guest"
HOST = "0.0.0.0"
PORT = 42020
CLTS = 1
PTAV = PORT

# Client configuration
active = False			# Controls when we have an active chat window
socks = []				# List of sockets
clients = []			# List of clients
servers = []			# List of servers
interval = 1			# Interval to sleep (1sec = default)

# Clear function (keepin' things clean ;)
clf = 'clear'
if os.name == 'posix': clf = 'clear'
if os.name == 'nt': clf = 'cls'
clear = lambda: os.system(clf)

# Get time function
ts = time.time()
st = datetime.datetime.fromtimestamp(ts).strftime('%H:%M')
def GetTime():
	ts = time.time()
	st = datetime.datetime.fromtimestamp(ts).strftime('%H:%M')
	return st

# Send data function
def Send(sock, data, end="EOFX"):
	sock.sendall(data + end)

# Receive data function
def Receive(sock, end="EOFX"):
	data = ""
	l = sock.recv(1024)
	while(l):
		data = l
		if data.endswith(end) == True:
			break
		else:
			l = sock.recv(1024)
	return data[:-len(end)]

# Check if host and address is in use
def CheckAddr(port, verbose):
	sc = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
	result = False
	try:
		sc.bind((HOST, port))
		result = True
		if verbose: print "\n[" + GetTime() + "] Host: " + str(HOST) + " and Port: " + str(port) + " is avaible..."
	except:
		if verbose: print "\n[" + GetTime() + "] Host: " + str(HOST) + " and Port: " + str(port) + " is currently in use."
	sc.close()
	time.sleep(interval)
	return result

# Function to allocate a port
def AllocAddress():
	global PTAV
	# Let's determine an available port for the new client
	while True:
		PTAV += 1
		if CheckAddr(PTAV, False): break
		# Limit port to 200
		if (PTAV-PORT) > 200: break

# Server handler
# --------------------------------------------
# This function will listen for connections as daemons
# and keep connected in background.
def ServerHandler(serverIP, serverPort, clientIP):
	sh = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
	sh.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
	sh.bind((serverIP, serverPort))
	sh.listen(1)	# Listen for 1 client, each server = 1 client

	z,b = sh.accept()
	if (z):
		print "\n[" + GetTime() + "] Connection from " + str(b)
		while True:
			msg = Receive(z)
			if len(str(msg)): print "\n[" + GetTime() + "] " + msg 

# Username prompt and print it
clear()
try:
	usr = raw_input("\n[*] Enter username: ")
	if len(usr) < 1:
		USER = "Guest"
	else:
		USER = usr
except:
	USER = "Guest"

# Let's greet the user!
print "\n[" + GetTime() + "] Welcome " + USER + "!"

# Initialize the server socket
if CheckAddr(PORT, True):
	c = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
	c.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
	c.bind((HOST, PORT))
	c.listen(CLTS)			# Listen for total of X clients
	print "\n[" + GetTime() + "] Listening on " + HOST + " (" + str(PORT) + ") for a total of " + str(CLTS) + " clients."
else:
	print "\n[" + GetTime() + "] Error - " + HOST + " (" + str(PORT) + ") is already in use."

# Server testing begins here ------------------------->

time.sleep(interval*2)

s,a = c.accept()
if (s):
	print "\n[" + GetTime() + "] Connection from " + str(a)

	try:
		while True:
			msg = Receive(s)
			if len(str(msg)): print "\n[" + GetTime() + "] " + msg
			if msg == "Time for message number two! Ayyy ;)":
				print "\n[" + GetTime() + "] Negotiating private connection."

				time.sleep(interval)

				ns = socket.socket(socket.AF_INET, socket.SOCK_STREAM) 
				print "\n[" + GetTime() + "] Connecting back to client: " + str(a) + " (" + str(PORT) + ")"
				ns.connect((a[0], PORT))

				time.sleep(interval)

				Send(ns, "Can you receive a message tho?")

				# Ok, let's figure out a port for the client to connect to
				AllocAddress()

				

				time.sleep(interval)

				# Let's start a new server thread to listen for single connection
				shtname = 'ServerT' + str(PTAV)
				print "\n[" + GetTime() + "] Starting server thread " + shtname
				sht = threading.Thread(name=shtname, target=ServerHandler, args=(HOST, PTAV, a[0]))
				servers.append(sht)
				sht.setDaemon(True)
				sht.start()
				
				time.sleep(interval)

				Send(ns, 'port: ' + str(PTAV))

				print "\n[" + GetTime() + "] Server thread " + shtname + " open."

				time.sleep(interval)

				break
	except KeyboardInterrupt:
		print ">>> Finished."

# Stay alive while threads are running
while True:
	for x in servers:
		if x.isAlive(): time.sleep(interval)